@openwop/openwop-conformance 2.5.0 → 2.6.1

This diff represents the content of publicly available package versions that have been released to one of the supported registries. The information contained in this diff is provided for informational purposes only and reflects changes between package versions as they appear in their respective public registries.
package/CHANGELOG.md CHANGED
@@ -1,5 +1,36 @@
1
1
  # `@openwop/openwop-conformance` Changelog
2
2
 
3
+ ## [2.6.1] — 2026-09-18 — the correction that half-landed
4
+
5
+ **Why a patch.** No conformance code changes; two schema descriptions.
6
+
7
+ ### Fixed
8
+
9
+ - The unsatisfiable `deliveryId == causationId` claim survived 2.6.0 on
10
+ `run-event-payloads.schema.json`'s `triggerDeliveryAttempted.runId` — the
11
+ durable event-log payload, and the more load-bearing of the two sites.
12
+ - `trigger-event.schema.json` pointed the causing-delivery seat at
13
+ `webhooks.md`, which is the OUTBOUND document for an INBOUND pointer.
14
+
15
+ ## [2.6.0] — 2026-09-18 — a relaxed profile cannot certify, and five corpus ids for the umbrella
16
+
17
+ ### Fixed
18
+
19
+ - **`--certify` wrote `certified: true` for a profile carrying a relaxation.**
20
+ `security-defaults.md` §Relaxations and RFC 0173 §A.2 both say it MUST NOT.
21
+ The predicate had no relaxation term and parsed relaxations on the next line;
22
+ the emitter then excluded `relaxed-profile-certified` from its self-check and
23
+ exited 0, so only `--verify` disagreed with the shipped file. Relaxations are
24
+ now parsed first and folded into the verdict, matched exactly as the verifier
25
+ matches them.
26
+
27
+ ### Added
28
+
29
+ - Five `src/coherence/` wrappers minting `openwop.requirement.0167.*`, so the v2
30
+ umbrella's falsifiability table stops passing rule 4 on zero ids. One spawns
31
+ `check-codemods.mjs --at-active`, which the merge gate never ran.
32
+ - `apps/workflow-engine` added to the public-docs banned-pattern scan.
33
+
3
34
  ## [2.5.0] — 2026-09-18 — `--verify`, for auditing a bundle you did not cut
4
35
 
5
36
  ### Added
package/README.md CHANGED
@@ -11,7 +11,7 @@
11
11
  # --legacy-peer-deps is REQUIRED, not optional: the exact peer pin is what npm's
12
12
  # default resolver refuses. npm 10.9 fails outright with
13
13
  # "Cannot read properties of null (reading 'edgesOut')" — use npm >= 11.
14
- npm install --legacy-peer-deps @openwop/openwop-conformance@2.5.0 @openwop/spec-artifacts@2.5.0
14
+ npm install --legacy-peer-deps @openwop/openwop-conformance@2.6.1 @openwop/spec-artifacts@2.6.1
15
15
  # or run without install:
16
16
  npx @openwop/openwop-conformance --base-url https://api.example.com --api-key hk_test_...
17
17
  ```
@@ -99,6 +99,8 @@ Run `npm run test` for normal CI cadence; `npm run test:strict` when claiming fu
99
99
 
100
100
  | Variable | Effect |
101
101
  | ----------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
102
+ | `OPENWOP_HOST_RELAXATIONS` | Sets `host.relaxations[]` in the bundle. **It relaxes nothing in the suite** — it is your declaration that the HOST runs relaxed, and the suite cannot detect an undeclared one. A profile carrying a relaxation **cannot certify** (`security-defaults.md` §Relaxations, RFC 0173 §A.2), and since 2.6.0 the emitter enforces that rather than writing `certified: true` and leaving the contradiction to `--verify`. JSON array of `{obligation, durability, reason}`; `durability` is `session \| deployment \| persisted` — **not** `permanent`. Unparseable JSON exits 2; a wrong enum value exits 2 later, at schema validation. |
103
+ | `OPENWOP_TARGET_MAJOR` | Selects the scenario lane. **Only the literal `"2"` selects major 2** — unlike `--target-major`, which validates and exits 2 on a bad value, the env var falls back to major 1 for `"1"`, `"3"`, `"two"` or empty. The runner and every vitest worker MUST see the same value: when they disagreed, the worker minted `openwop.floor.*` while the runner looked up `openwop.scenario.*`, producing a vacuous-pass emitter defect and **no bundle at all**. Prefer `--target-major`; set this only when driving `vitest` directly. |
102
104
  | `OPENWOP_REQUIRE_BEHAVIOR=true` | Capability-gated scenarios (audit-log integrity, rate-limit envelope, multi-region idempotency, `configurableSchema`, webhook sig versioning, etc.) FAIL instead of skipping when the host doesn't advertise the profile. Lets a host claim "full coverage" mechanically. See [`coverage.md`](./coverage.md) §"Capability-gated scenarios". |
103
105
  | `OPENWOP_TEST_PUBLIC_REGISTRY=true` | Runs `registry-public.test.ts` against the hosted registry at `packs.openwop.dev`. Skipped by default so the suite doesn't depend on outbound connectivity. |
104
106
  | `OPENWOP_OTEL_COLLECTOR=true` | Boots the in-suite OTLP collector for `otel-emission.test.ts`, `otel-trace-propagation.test.ts`, `metric-emission.test.ts`, and `otel-emission-grpc.test.ts`. The collector accepts OTLP/HTTP-JSON (`application/json`), OTLP/HTTP-protobuf (`application/x-protobuf` — hand-rolled decoder at `src/lib/otlp-protobuf.ts`), and OTLP/gRPC (when `OPENWOP_OTEL_COLLECTOR_GRPC=true` — h2c HTTP/2 + hand-rolled framing at `src/lib/grpc-framing.ts`). Zero new npm deps. Hosts may emit via `OTEL_EXPORTER_OTLP_PROTOCOL=http/json`, `http/protobuf`, or `grpc`. Skipped by default. **Run OTel scenarios with `--no-file-parallelism`** — each vitest worker spawns its own collector and only one can bind the same port, so concurrent file execution causes ephemeral-port fallbacks that don't receive the host's OTLP traffic. |
package/dist/cli.js CHANGED
@@ -640,7 +640,16 @@ async function runCertify(args, baseUrl, apiKey) {
640
640
  // `certified` IS the verdict (RFC 0148 §A; RFC 0168 §E.1 adds the bundle-wide
641
641
  // blocked rule). Until rc.45 it was `!notHeld && !rejected && blocked === 0`
642
642
  // and never read `certifiable` — an empty v2 floor certified on no evidence.
643
- const claimed3 = claimedProfiles.filter((p) => !(p in DEPRECATED_PROFILE_ALIASES)).map((p) => ({ id: p, evidenceTier: args.evidenceTier, witnessCount: witnessCountFor(p), certified: (verdictFor(p)?.certifiable ?? false) && !notHeld.has(p) && !rejectedProfiles.some((v) => v.profile === p) && totals3.blocked === 0 }));
643
+ // Relaxations are parsed BEFORE the verdict, because they are part of it.
644
+ // `security-defaults.md` §Relaxations is explicit: "A bundle that records a
645
+ // relaxation MUST NOT certify the profile the relaxed obligation belongs to"
646
+ // (RFC 0173 §A.2). The emitter computed `certified` with no relaxation term —
647
+ // and parsed relaxations on the NEXT line, so it was structurally impossible
648
+ // for one to affect the verdict — then excluded `relaxed-profile-certified`
649
+ // from its own self-check. The shipped artifact asserted `certified: true`
650
+ // for a profile that cannot certify, and only `--verify` disagreed with the
651
+ // file. A reader who parses `.certified` — the obvious thing to do — got the
652
+ // wrong answer.
644
653
  let relaxations;
645
654
  if (process.env['OPENWOP_HOST_RELAXATIONS']) {
646
655
  try {
@@ -651,6 +660,12 @@ async function runCertify(args, baseUrl, apiKey) {
651
660
  process.exit(2);
652
661
  }
653
662
  }
663
+ // RFC 0173 §A.2: a recorded relaxation denies the profile its obligation
664
+ // belongs to. Matched the same way the verifier matches it, so the emitter
665
+ // and `verifyBundleV3` cannot disagree about the same bundle.
666
+ const relaxedObligations = new Set((relaxations ?? []).map((r) => r.obligation));
667
+ const relaxedProfile = (p) => [...relaxedObligations].some((o) => p.includes(o));
668
+ const claimed3 = claimedProfiles.filter((p) => !(p in DEPRECATED_PROFILE_ALIASES)).map((p) => ({ id: p, evidenceTier: args.evidenceTier, witnessCount: witnessCountFor(p), certified: !relaxedProfile(p) && (verdictFor(p)?.certifiable ?? false) && !notHeld.has(p) && !rejectedProfiles.some((v) => v.profile === p) && totals3.blocked === 0 }));
654
669
  const lockPath = resolvePath(conformanceRoot, 'dist', 'spec-artifacts.lock.json');
655
670
  const lock = existsSync(lockPath) ? JSON.parse(readFileSync(lockPath, 'utf8')) : undefined;
656
671
  const nonPass = rows3.filter((r) => r.result !== 'executed-pass');
@@ -688,7 +703,10 @@ async function runCertify(args, baseUrl, apiKey) {
688
703
  const scrubbed3 = scrubEvidence(v3, secrets3);
689
704
  const v3Out = scrubbed3.value;
690
705
  const audit3 = verifyBundleV3(v3Out, { hostPublicKeyPem: publicKeyFromPrivate(signingKeyPem) });
691
- const emitterDefects = audit3.rejections.filter((r) => !['blocked-certified', 'relaxed-profile-certified', 'independent-unverifiable'].includes(r.kind));
706
+ // `relaxed-profile-certified` is no longer excused: the emitter now computes
707
+ // the relaxation into `certified`, so if the verifier still finds that
708
+ // contradiction the bundle is genuinely malformed and MUST NOT be written.
709
+ const emitterDefects = audit3.rejections.filter((r) => !['blocked-certified', 'independent-unverifiable'].includes(r.kind));
692
710
  if (emitterDefects.length > 0) {
693
711
  // Keep the rejected bundle: a self-verification failure with nothing to
694
712
  // inspect sent a host patching a scratch copy of this CLI to see it.
@@ -1,5 +1,5 @@
1
1
  {
2
2
  "package": "@openwop/spec-artifacts",
3
- "version": "2.5.0",
4
- "stampSha256": "6f34c35c619eccc3b472a465b4c0233e56872a2bd48d04e045fc173a70148aaf"
3
+ "version": "2.6.1",
4
+ "stampSha256": "e60f431e0c9a58f930a5809b7ff593c13a492accfd6ab0873342bb4a96d0e2a0"
5
5
  }
package/package.json CHANGED
@@ -1,6 +1,6 @@
1
1
  {
2
2
  "name": "@openwop/openwop-conformance",
3
- "version": "2.5.0",
3
+ "version": "2.6.1",
4
4
  "description": "Production-ready black-box conformance suite for OpenWOP v1.0 compliant servers.",
5
5
  "repository": {
6
6
  "type": "git",
@@ -56,6 +56,6 @@
56
56
  "@openwop/spec-artifacts": "file:../spec-artifacts"
57
57
  },
58
58
  "peerDependencies": {
59
- "@openwop/spec-artifacts": "2.5.0"
59
+ "@openwop/spec-artifacts": "2.6.1"
60
60
  }
61
61
  }
package/requirements.json CHANGED
@@ -2,11 +2,11 @@
2
2
  "$comment": "GENERATED by conformance/scripts/generate-requirement-registry.mjs — do not edit. One record per it()/test() in src/scenarios. Ids: openwop.it.<file-stem>.<title-slug>[~n] (src/lib/requirement-ids.ts). A record with id null has an interpolated title; its run-time row is keyed by the rendered title and maps here by file+line only. Renamed ids need a row in requirement-aliases.json.",
3
3
  "generatedFrom": "src/scenarios/*.test.ts",
4
4
  "counts": {
5
- "files": 571,
6
- "tests": 2174,
7
- "withStableId": 2174,
5
+ "files": 576,
6
+ "tests": 2179,
7
+ "withStableId": 2179,
8
8
  "interpolatedTitles": 0,
9
- "explicitIds": 2127
9
+ "explicitIds": 2132
10
10
  },
11
11
  "records": [
12
12
  {
@@ -35390,7 +35390,7 @@
35390
35390
  {
35391
35391
  "id": "openwop.it.spec-corpus-validity.scans-public-docs-and-schemas",
35392
35392
  "file": "spec-corpus-validity.test.ts",
35393
- "line": 1397,
35393
+ "line": 1406,
35394
35394
  "title": "scans public docs and schemas",
35395
35395
  "explicitId": "openwop.it.spec-corpus-validity.scans-public-docs-and-schemas",
35396
35396
  "citations": [
@@ -35403,7 +35403,7 @@
35403
35403
  {
35404
35404
  "id": "openwop.it.spec-corpus-validity.has-no-private-implementation-or-pre-v1-breadcrumbs",
35405
35405
  "file": "spec-corpus-validity.test.ts",
35406
- "line": 1403,
35406
+ "line": 1412,
35407
35407
  "title": null,
35408
35408
  "explicitId": "openwop.it.spec-corpus-validity.has-no-private-implementation-or-pre-v1-breadcrumbs",
35409
35409
  "citations": [
@@ -35417,7 +35417,7 @@
35417
35417
  {
35418
35418
  "id": "openwop.it.spec-corpus-validity.every-fixture-id-mentioned-in-fixtures-md-has-a-corresponding-json",
35419
35419
  "file": "spec-corpus-validity.test.ts",
35420
- "line": 1432,
35420
+ "line": 1441,
35421
35421
  "title": "every fixture id mentioned in fixtures.md has a corresponding JSON",
35422
35422
  "explicitId": "openwop.it.spec-corpus-validity.every-fixture-id-mentioned-in-fixtures-md-has-a-corresponding-json",
35423
35423
  "citations": [
@@ -35431,7 +35431,7 @@
35431
35431
  {
35432
35432
  "id": "openwop.it.spec-corpus-validity.every-fixture-json-file-is-referenced-by-fixtures-md",
35433
35433
  "file": "spec-corpus-validity.test.ts",
35434
- "line": 1474,
35434
+ "line": 1483,
35435
35435
  "title": "every fixture JSON file is referenced by fixtures.md",
35436
35436
  "explicitId": "openwop.it.spec-corpus-validity.every-fixture-json-file-is-referenced-by-fixtures-md",
35437
35437
  "citations": [
@@ -35445,7 +35445,7 @@
35445
35445
  {
35446
35446
  "id": "openwop.it.spec-corpus-validity.a-sample-bundle-validates-against-conformance-certification-bundle-schema-json",
35447
35447
  "file": "spec-corpus-validity.test.ts",
35448
- "line": 1527,
35448
+ "line": 1536,
35449
35449
  "title": "a sample bundle validates against conformance-certification-bundle.schema.json",
35450
35450
  "explicitId": "openwop.it.spec-corpus-validity.a-sample-bundle-validates-against-conformance-certification-bundle-schema-json",
35451
35451
  "citations": [
@@ -35459,7 +35459,7 @@
35459
35459
  {
35460
35460
  "id": "openwop.it.spec-corpus-validity.verifybundle-accepts-a-claim-that-is-discovery-derivable-and-floor-proven-b",
35461
35461
  "file": "spec-corpus-validity.test.ts",
35462
- "line": 1533,
35462
+ "line": 1542,
35463
35463
  "title": "verifyBundle ACCEPTS a claim that is discovery-derivable AND floor-proven (§B)",
35464
35464
  "explicitId": "openwop.it.spec-corpus-validity.verifybundle-accepts-a-claim-that-is-discovery-derivable-and-floor-proven-b",
35465
35465
  "citations": [
@@ -35472,7 +35472,7 @@
35472
35472
  {
35473
35473
  "id": "openwop.it.spec-corpus-validity.verifybundle-rejects-a-profile-its-discovery-document-does-not-derive-b-1",
35474
35474
  "file": "spec-corpus-validity.test.ts",
35475
- "line": 1540,
35475
+ "line": 1549,
35476
35476
  "title": "verifyBundle REJECTS a profile its discovery document does not derive (§B(1))",
35477
35477
  "explicitId": "openwop.it.spec-corpus-validity.verifybundle-rejects-a-profile-its-discovery-document-does-not-derive-b-1",
35478
35478
  "citations": [
@@ -35485,7 +35485,7 @@
35485
35485
  {
35486
35486
  "id": "openwop.it.spec-corpus-validity.verifybundle-rejects-a-bundle-missing-a-floor-scenario-b-2",
35487
35487
  "file": "spec-corpus-validity.test.ts",
35488
- "line": 1550,
35488
+ "line": 1559,
35489
35489
  "title": "verifyBundle REJECTS a bundle missing a floor scenario (§B(2))",
35490
35490
  "explicitId": "openwop.it.spec-corpus-validity.verifybundle-rejects-a-bundle-missing-a-floor-scenario-b-2",
35491
35491
  "citations": [
@@ -35498,7 +35498,7 @@
35498
35498
  {
35499
35499
  "id": "openwop.it.spec-corpus-validity.the-committed-bundle-file-exists-generated-by-certify",
35500
35500
  "file": "spec-corpus-validity.test.ts",
35501
- "line": 1587,
35501
+ "line": 1596,
35502
35502
  "title": "the committed bundle file exists (generated by --certify)",
35503
35503
  "explicitId": "openwop.it.spec-corpus-validity.the-committed-bundle-file-exists-generated-by-certify",
35504
35504
  "citations": [
@@ -35512,7 +35512,7 @@
35512
35512
  {
35513
35513
  "id": "openwop.it.spec-corpus-validity.the-committed-reference-bundle-validates-against-the-bundle-schema-a",
35514
35514
  "file": "spec-corpus-validity.test.ts",
35515
- "line": 1591,
35515
+ "line": 1600,
35516
35516
  "title": "the committed reference bundle validates against the bundle schema (§A)",
35517
35517
  "explicitId": "openwop.it.spec-corpus-validity.the-committed-reference-bundle-validates-against-the-bundle-schema-a",
35518
35518
  "citations": [
@@ -35526,7 +35526,7 @@
35526
35526
  {
35527
35527
  "id": "openwop.it.spec-corpus-validity.verifybundle-rejects-the-committed-reference-bundle-it-is-invalidated-rfc-0148-d",
35528
35528
  "file": "spec-corpus-validity.test.ts",
35529
- "line": 1598,
35529
+ "line": 1607,
35530
35530
  "title": "verifyBundle REJECTS the committed reference bundle — it is `invalidated` (RFC 0148 §D)",
35531
35531
  "explicitId": "openwop.it.spec-corpus-validity.verifybundle-rejects-the-committed-reference-bundle-it-is-invalidated-rfc-0148-d",
35532
35532
  "citations": [
@@ -35547,7 +35547,7 @@
35547
35547
  {
35548
35548
  "id": "openwop.it.spec-corpus-validity.discovery-sha256-is-the-canonical-json-sha-256-of-the-captured-discovery-documen",
35549
35549
  "file": "spec-corpus-validity.test.ts",
35550
- "line": 1624,
35550
+ "line": 1633,
35551
35551
  "title": "discovery.sha256 is the canonical-JSON SHA-256 of the captured discovery.document",
35552
35552
  "explicitId": "openwop.it.spec-corpus-validity.discovery-sha256-is-the-canonical-json-sha-256-of-the-captured-discovery-documen",
35553
35553
  "citations": [
@@ -35560,7 +35560,7 @@
35560
35560
  {
35561
35561
  "id": "openwop.it.spec-corpus-validity.the-requestbody-closes-at-the-composition-unevaluatedproperties-not-inside-a-bra",
35562
35562
  "file": "spec-corpus-validity.test.ts",
35563
- "line": 1685,
35563
+ "line": 1694,
35564
35564
  "title": "the requestBody closes at the composition (unevaluatedProperties), not inside a branch",
35565
35565
  "explicitId": "openwop.it.spec-corpus-validity.the-requestbody-closes-at-the-composition-unevaluatedproperties-not-inside-a-bra",
35566
35566
  "citations": [
@@ -35573,7 +35573,7 @@
35573
35573
  {
35574
35574
  "id": "openwop.it.spec-corpus-validity.canonical-createrun-bodies-pass-the-composed-schema-an-undeclared-property-fails",
35575
35575
  "file": "spec-corpus-validity.test.ts",
35576
- "line": 1700,
35576
+ "line": 1709,
35577
35577
  "title": "canonical createRun bodies PASS the composed schema; an undeclared property FAILS",
35578
35578
  "explicitId": "openwop.it.spec-corpus-validity.canonical-createrun-bodies-pass-the-composed-schema-an-undeclared-property-fails",
35579
35579
  "citations": [
@@ -36221,6 +36221,81 @@
36221
36221
  }
36222
36222
  ]
36223
36223
  },
36224
+ {
36225
+ "id": "openwop.it.v2-umbrella-alias-covered.the-corpus-gate-script-exits-0",
36226
+ "file": "v2-umbrella-alias-covered.test.ts",
36227
+ "line": 32,
36228
+ "title": "the corpus gate script exits 0",
36229
+ "explicitId": "openwop.requirement.0167.alias-covered",
36230
+ "citations": [
36231
+ {
36232
+ "section": "RFC 0167 §E.2",
36233
+ "requirement": null,
36234
+ "interpolated": true
36235
+ }
36236
+ ]
36237
+ },
36238
+ {
36239
+ "id": "openwop.it.v2-umbrella-child-parts.the-corpus-gate-script-exits-0",
36240
+ "file": "v2-umbrella-child-parts.test.ts",
36241
+ "line": 33,
36242
+ "title": "the corpus gate script exits 0",
36243
+ "explicitId": "openwop.requirement.0167.child-parts",
36244
+ "citations": [
36245
+ {
36246
+ "section": "RFC 0167 §C",
36247
+ "requirement": null,
36248
+ "interpolated": true
36249
+ },
36250
+ {
36251
+ "section": "RFC 0167 §C",
36252
+ "requirement": null,
36253
+ "interpolated": true
36254
+ }
36255
+ ]
36256
+ },
36257
+ {
36258
+ "id": "openwop.it.v2-umbrella-codemod-at-active.the-corpus-gate-script-exits-0",
36259
+ "file": "v2-umbrella-codemod-at-active.test.ts",
36260
+ "line": 32,
36261
+ "title": "the corpus gate script exits 0",
36262
+ "explicitId": "openwop.requirement.0167.codemod-at-active",
36263
+ "citations": [
36264
+ {
36265
+ "section": "RFC 0167 §D.3",
36266
+ "requirement": null,
36267
+ "interpolated": true
36268
+ }
36269
+ ]
36270
+ },
36271
+ {
36272
+ "id": "openwop.it.v2-umbrella-codemod-legs.the-corpus-gate-script-exits-0",
36273
+ "file": "v2-umbrella-codemod-legs.test.ts",
36274
+ "line": 32,
36275
+ "title": "the corpus gate script exits 0",
36276
+ "explicitId": "openwop.requirement.0167.codemod-legs",
36277
+ "citations": [
36278
+ {
36279
+ "section": "RFC 0167 §D.3",
36280
+ "requirement": null,
36281
+ "interpolated": true
36282
+ }
36283
+ ]
36284
+ },
36285
+ {
36286
+ "id": "openwop.it.v2-umbrella-migration-deprecation.the-corpus-gate-script-exits-0",
36287
+ "file": "v2-umbrella-migration-deprecation.test.ts",
36288
+ "line": 32,
36289
+ "title": "the corpus gate script exits 0",
36290
+ "explicitId": "openwop.requirement.0167.migration-deprecation-bound",
36291
+ "citations": [
36292
+ {
36293
+ "section": "RFC 0167 §D.1",
36294
+ "requirement": null,
36295
+ "interpolated": true
36296
+ }
36297
+ ]
36298
+ },
36224
36299
  {
36225
36300
  "id": "openwop.it.v2-witness-required.the-corpus-gate-script-exits-0",
36226
36301
  "file": "v2-witness-required.test.ts",
@@ -1,17 +1,17 @@
1
1
  {
2
2
  "_comment": "Provenance of @openwop/spec-artifacts (RFC 0168 §D.2). files: SHA-256 per file; the conformance suite compares the installed peer against dist/spec-artifacts.lock.json at start.",
3
3
  "package": "@openwop/spec-artifacts",
4
- "version": "2.5.0",
5
- "corpusTag": "v2.5.0",
4
+ "version": "2.6.1",
5
+ "corpusTag": "v2.6.1",
6
6
  "files": {
7
7
  "api/.redocly.lint-ignore.yaml": "bf5a8350b88a72fa43f59605ed8d903ed24b6cfccda5e45509c9f6ed9ee4e712",
8
8
  "api/asyncapi.yaml": "d5ecb9ee6114582be3b1f662c84bfac9ae96dae7bacb853e461168f70a8e1c7d",
9
9
  "api/grpc/openwop.proto": "c3e72bb17cba514ee98feb6434e6c9b6ea6795bfd086489ec69fd882dd1ad977",
10
10
  "api/openapi.yaml": "39081c59fb696159806b0f2f9a42e7e9ff830d622fcf2ad4159b21357580a955",
11
11
  "api/redocly.yaml": "b0604c89b2ca6d5076ec25725c539dad44a741a811fe524439ee6daef8baa09f",
12
- "api/seams-v2.yaml": "f35db54139898b07150e0a2a40ce6ef380aac3768b1bd72e41ac2e32dc102daf",
13
- "api/v2/asyncapi.yaml": "b5d7c42d6d2b7aa3b392762b4544e90017fe9ab53cfbcb28488c96f1b2ede93d",
14
- "api/v2/openapi.yaml": "a026b36f9228b5216b544c105e99bc1d0eb27e4702fb05c696576ce79d52c9cc",
12
+ "api/seams-v2.yaml": "daa6cb47c2fb29b8c1ff596c7c00a494a9a48c795ddd0485f9d89e3a1656baf6",
13
+ "api/v2/asyncapi.yaml": "29f449a6b3386b4d6db141bc3cf0342f45850a9b3cc74dcf999bbdc5d8d1a57d",
14
+ "api/v2/openapi.yaml": "a09adf882b9ac3a344caf16d1ea916cc1795a38544eb2e5df923f84129e86c6f",
15
15
  "api/v2/redocly.yaml": "1e66b60e6118ad11a823bb620678be464d99dfe50a40e3e6f93ec9429b88b34c",
16
16
  "schemas/README.md": "0c0b737ffcf8f30e7d2809cec8a498232de710f41443212922ad8337cdde0b51",
17
17
  "schemas/a2a-task-state.schema.json": "c9365918f993f943b4b619d42551eb066a1ed33a08d895d51b395432a5b1f1bc",
@@ -116,7 +116,7 @@
116
116
  "schemas/v2/audit-verify-result.schema.json": "a748dfadb5155adfde8a91045e76b0db6695005fe559035d71670fdd55edb3ba",
117
117
  "schemas/v2/budget-policy.schema.json": "c7449daeb6e1d95e7a047b8c2814d3d54748697c27046972834874867d9b5f4c",
118
118
  "schemas/v2/capabilities.schema.json": "fa9b80a9107fc322ecadbac808e7fbe5e16ccf0af1a6bf673181faa8379dde33",
119
- "schemas/v2/certification-bundle.schema.json": "d2cbc5cadddff13630a528dc9673162f582c035c6a6663ca02c1ac53e8fec40c",
119
+ "schemas/v2/certification-bundle.schema.json": "0bcf8f297266505ca39d30eea8100e3c0fb048f2651717fd746da8129fcb7920",
120
120
  "schemas/v2/channel-presence-payload.schema.json": "1c20ad810cb311d47aa0b95d928490826b2468fd161f884cd29e867053e6782f",
121
121
  "schemas/v2/channel-written-payload.schema.json": "ccecff3c71a3275ad8db035ac0e04db25e6f8d23cf091ddbcd5a60d1be1cbb6b",
122
122
  "schemas/v2/chat-card-pack-manifest.schema.json": "8df0d9d273ae22efc6876d5586833f1d4c2e551edc3ac6cf6e8f0719329f03dd",
@@ -169,7 +169,7 @@
169
169
  "schemas/v2/residency.schema.json": "3fd23c9732beb140504e81560fc426eb6764d547e56da5fb92c5a5c7bf04db3a",
170
170
  "schemas/v2/run-ancestry-response.schema.json": "334c17f2062dea62726ca1d07b8be3f169cdc422af843c1def5fb317039814c9",
171
171
  "schemas/v2/run-diff-response.schema.json": "8bdb2045c274580038bd74781f7d062f5049839797c164a89de4ed89edc53a74",
172
- "schemas/v2/run-event-payloads.schema.json": "29dec16f0d40c9022c169d4d413742ddd775a3d8c895d3a60ccc093e2a872439",
172
+ "schemas/v2/run-event-payloads.schema.json": "ec5c934b9ef80404bd4ddc9e715cd1629fc7e7934d09d3eb81b65dcef2e2ff9a",
173
173
  "schemas/v2/run-event.schema.json": "2f0d7416bd376c56affe97b6b2b49981532e8e9ff45c0a162cf806c78b3e7fb7",
174
174
  "schemas/v2/run-list-response.schema.json": "c2dbc34768dcf64528914a213aa3cb55952e8e3e90a64b04a9423b2a19749d38",
175
175
  "schemas/v2/run-options.schema.json": "f0e9f494d80086c2ed2cf9fe87df54e5b4e66601699c4a1089f4edbc7ba58867",
@@ -183,7 +183,7 @@
183
183
  "schemas/v2/subject.schema.json": "094e981fb20052a911393e219ea5f2065d8b8417b65080a70c5ea99fd960a8fe",
184
184
  "schemas/v2/suspend-request.schema.json": "4a0dda88a257cdb21c9b57fc9ad898d91de0d75bc4944a693eb950b709f58c91",
185
185
  "schemas/v2/tool-descriptor.schema.json": "658b18ef173e0f12d732f92d4866a9b3daeb8f88b493db8b025a577e09dd681c",
186
- "schemas/v2/trigger-event.schema.json": "66077c3b3d5b81591270655643ae8957c4c42aaf7cf31c45e8e45cb1b73fde63",
186
+ "schemas/v2/trigger-event.schema.json": "4e61e5a761b7eb71c9d36536eea4341dd5db21262e64d720f9c81b18d57c4dd0",
187
187
  "schemas/v2/trigger-subscription-registration.schema.json": "04bc314a07c7e8b565577cb8df5821d968ce2af915900dfdccd4a24e928d20db",
188
188
  "schemas/v2/trigger-subscription.schema.json": "c887d4b9a12be0133f8c9dfd3a8bafcb518e27ecc2e800447ebc4d1fef111503",
189
189
  "schemas/v2/ui-plugin-message.schema.json": "879d65867c01656b3962d64283e66364dcb8f626ad26c5fcf2d2d55a79ae0ce9",
@@ -200,7 +200,7 @@
200
200
  "schemas/workspace-file.schema.json": "464de85c2a068243084ee9c1d969bc7cd5d8f7948574e58450d6493c38a0e1e4",
201
201
  "spec/v1/alias-detectors.json": "e90916db12d2297e2e560b2d54d2c4702d6cb3bef7179a575844687a7ec17262",
202
202
  "spec/v1/capability-declaration-classes.json": "e7729aed5c4b4e1dd02abab0530f14cc95f5d4070fe51fb139e7f5cccefa00c6",
203
- "spec/v1/core-standard-manifest.json": "c1b2629f9d2a374fd9121c1f5ce906e7c4225798c49373cb66f9064050b23bb7",
203
+ "spec/v1/core-standard-manifest.json": "530dedda95648cf9eedd160bf8c0e582ec2a1b8daccbfe81b884d90e4eb81eec",
204
204
  "spec/v1/deprecations.json": "c81c8f71460936c8d489d8270477c7661cf4a5d7b7bad86c98899750b5656027",
205
205
  "spec/v1/deprecations.schema.json": "18c87e78bedc210431f795ae44c5b5d202f2f3317850d5cf86867d4f1fa1cdfb",
206
206
  "spec/v1/event-codemap.json": "3da60d884157793a360da532a9fcbbfb5285636db325a74cec94b34622186d97",
@@ -213,26 +213,26 @@
213
213
  "spec/v1/operation-path-manifest.json": "5f5f4e3842669371730ebbd1aace3fb794192615f0018dc144f484ba5db82ac3",
214
214
  "spec/v1/spec-gaps.json": "eb3bfcb9c7d05c9a6845d4a40ec9493cfaa5a671932daf1af561310136fdabe8",
215
215
  "spec/v2/README.md": "5d49f56f41e06b44312c61ad8144b786c9a90ec42fd0660a40d89520ef206137",
216
- "spec/v2/core/capabilities.md": "c5107a4964e487c20bbb5254cfe1f706e0d9ba7e34da9070bc43b50b385e7948",
217
- "spec/v2/core/conformance.md": "b8d7dae142e3708a7597533cb77827363b6cfc91b89538081a9afe5e23c975f4",
218
- "spec/v2/core/connection-packs.md": "1d759681e2962f5103228c52c45f24607ed4bb9ae73e30605f690c1d5a59e9ee",
219
- "spec/v2/core/errors.md": "ad85fc830139e587f20deabf88297b91b1fb6ce31e80d5442624a650246ab16e",
220
- "spec/v2/core/events.md": "f1bac16419740f3b722febb6f5caaabed8838e092cba3d080fe9184024049dcf",
221
- "spec/v2/core/form-content-packs.md": "6ffaae85d4550be48dd53fb6e2959af8aceb35bd87c5343b722885084f197713",
222
- "spec/v2/core/headers.md": "cc60370c7443752d462d032478bf23d976ec2efc2e9730cf76542a1d8be4cfc7",
223
- "spec/v2/core/idempotency.md": "b86c352d964aebad532727f314e26ed2177d49de382076fa64d3162e2f56118d",
224
- "spec/v2/core/identity.md": "9d2b823eb899463807452fe5721dcf09881837c161be024175957db27870b243",
225
- "spec/v2/core/interop.md": "d4c404e469e1d9d9be88bc2c939d777e7d7c1d0419b1251c18770f039838a401",
226
- "spec/v2/core/interrupt.md": "548c7a7bdfcab56db33dfad3d397cae2ed5f9828a63418021936eb392395e3e4",
227
- "spec/v2/core/overview.md": "69377c90bbb87b6bfe4b8be4f1b65810094b0759c8d4f93ca6df92cc530ea023",
228
- "spec/v2/core/packs.md": "8b3e1587270bb1aec814befbd287181a05b7f76aeb0802787ee7ebdc85901205",
229
- "spec/v2/core/persistence.md": "898dc929d021a03d245691148fe4fdec4582b4faa9237aa32037bbd3a2993b7d",
230
- "spec/v2/core/replay.md": "bd191a2565aa7ad0df9b35a0716f3de53be34b8722f1807c5e5b02859404a9b9",
231
- "spec/v2/core/runs.md": "f7a95fc82fda5b7c0c613de6e5edd376bbd6d8ba4c665a500c94eacbe42b86f2",
232
- "spec/v2/core/security-defaults.md": "d69a8dfc9057e189caa61f14810e3090b3b053e8fde419d09db84729a42b84c7",
233
- "spec/v2/core/versioning.md": "fd6564879cf043b68338db20b20de93755a1e7147000afb4738c07770deeddaf",
234
- "spec/v2/core/webhooks.md": "969c367650e5e93beb090242bcbec59f43b95bdf646fa6c512f6c7fa1f05912e",
235
- "spec/v2/core/workflow-chain-packs.md": "ef2b07d2d99334eaec0cc370314e2ad2f84ea58deb699e5d92e6e52d6056613f",
216
+ "spec/v2/core/capabilities.md": "35696991582729c86b5760f292251734e37cee45398fa5179764cefa5a91037f",
217
+ "spec/v2/core/conformance.md": "a451c0a2ba79d93c55e540ccef480eba7de9602d59bbb03eead05daafde0beac",
218
+ "spec/v2/core/connection-packs.md": "2e53c92476f68304139faf0c370874dc27bbba56a127a07e0906ff06edbb8ff1",
219
+ "spec/v2/core/errors.md": "c3ac131dff970ab7574629d72735ace52cc56cd4a7ab5d1206ce91f382bc9a68",
220
+ "spec/v2/core/events.md": "6ab8c727df3ebc5a60de3837c82a0075b4357d6f7e28435c6f80585687d41a76",
221
+ "spec/v2/core/form-content-packs.md": "d4c5295dfd28972be205c87c34d0d34ced64f4a2561ebff7f9d24b436d83df25",
222
+ "spec/v2/core/headers.md": "6c5eb48d998c141b5f0cb61fea926833a072748fdc4034e1a90a4dfe5448659c",
223
+ "spec/v2/core/idempotency.md": "803cd85947b1b2151cd2fb42cf0e0c52c9bcd19cdc6c23dcf34b1eddc600921a",
224
+ "spec/v2/core/identity.md": "ae24870df315b527dfe9ecf7a4c26582bcc1113da7954f44acf69bf463ac390d",
225
+ "spec/v2/core/interop.md": "8d8f4b040cb3625044c6aa586c8dcf5e9d15797de3d3b1cea631f44b8924701c",
226
+ "spec/v2/core/interrupt.md": "bdb2879a52a2504d84146e46108c4a4c2dd3a6f27865a295c80375b331cced21",
227
+ "spec/v2/core/overview.md": "7dc00ace32d4e4ce929a383651f0029fc4b7091ec87487b1bf26ead1be209e0e",
228
+ "spec/v2/core/packs.md": "3254fd060c2b690cea70ef2b1b1a119711bb04fb5f13bf8936d4d718df9b2322",
229
+ "spec/v2/core/persistence.md": "e75c6d8cc6a31747f8559931c420ed0debbdec16ae01fed28df5aa79a51e5899",
230
+ "spec/v2/core/replay.md": "dee513b6ca313a0647c853e713af94a3e077f3e58f71851ddb0ef8adcb3b0afe",
231
+ "spec/v2/core/runs.md": "b4c0bb2869077fcbf26e15bc6bbac06819f68b8241944b903a275a37db1c71fa",
232
+ "spec/v2/core/security-defaults.md": "9ab1d1a88ccd0929f354422b151ec6d3164e8cd3784f8e58bb6f11cb7ee1e7d5",
233
+ "spec/v2/core/versioning.md": "27b88cde88f9060567ef7e46f4897b6be8892ade9f4a46c2ab16e314c515eabd",
234
+ "spec/v2/core/webhooks.md": "ecec4d22a35aeafd34276bb0579ae28610e79ab8850ebf42188cb51bc946a093",
235
+ "spec/v2/core/workflow-chain-packs.md": "26bb65721f826285b7d90c3cb62fa7e9fb2414c1bc6e0fd25b33209168c3102e",
236
236
  "spec/v2/declaration.json": "a09bac61c1b825e4a77b5abc0f86f1f8c20c381e0650eb08c2f6d0ef0aaec1dc",
237
237
  "spec/v2/declaration.schema.json": "c86e3083fb9789c1958ecb4576cc6f71aa90e6f339521139238543ed08211dd4",
238
238
  "spec/v2/errors.json": "4ff032033f02d7e3fb4204581456408ba5e7642b438c1f349bbd1c264e63e419",
@@ -271,8 +271,8 @@
271
271
  "spec/v2/path-manifest.json": "a6f4e652e866889e8bde815874062f62929aee95dc8e58e7152c56adee262163",
272
272
  "spec/v2/peer-dependency-aliases.json": "d10299280abee08258502925bc327293ee413e0108cd6e6ec75ff6110653308d",
273
273
  "spec/v2/profiles.json": "0636f19fceae625390003a347e70ef4797d84766b5c24ce8a02cea52aadebca4",
274
- "spec/v2/release.json": "6d251f6f5ea4ce8478b97bcb6eb278c5d74539503696f0dc5c27b00cce9374f0",
274
+ "spec/v2/release.json": "5f3133ef7b959b76bb72c6b8e0fc7249bd93744c0b2431bdacb5fab43e4ae4a7",
275
275
  "spec/v2/retention-floors.json": "eaf3722d95c79947af1d4269ef85117e126518c588cfcf1a2b21b97269f51624"
276
276
  },
277
- "corpusCommit": "61d4b171eb376eb754e27b681d5aaf79fd92e46d"
277
+ "corpusCommit": "11c348ccb11f58a9bdb413030ab9d0366f71642d"
278
278
  }
package/src/cli.ts CHANGED
@@ -677,9 +677,24 @@ async function runCertify(args: ParsedArgs, baseUrl: string, apiKey: string): Pr
677
677
  // `certified` IS the verdict (RFC 0148 §A; RFC 0168 §E.1 adds the bundle-wide
678
678
  // blocked rule). Until rc.45 it was `!notHeld && !rejected && blocked === 0`
679
679
  // and never read `certifiable` — an empty v2 floor certified on no evidence.
680
- const claimed3 = claimedProfiles.filter((p) => !(p in DEPRECATED_PROFILE_ALIASES)).map((p) => ({ id: p, evidenceTier: args.evidenceTier, witnessCount: witnessCountFor(p), certified: (verdictFor(p)?.certifiable ?? false) && !notHeld.has(p) && !rejectedProfiles.some((v) => v.profile === p) && totals3.blocked === 0 }));
680
+ // Relaxations are parsed BEFORE the verdict, because they are part of it.
681
+ // `security-defaults.md` §Relaxations is explicit: "A bundle that records a
682
+ // relaxation MUST NOT certify the profile the relaxed obligation belongs to"
683
+ // (RFC 0173 §A.2). The emitter computed `certified` with no relaxation term —
684
+ // and parsed relaxations on the NEXT line, so it was structurally impossible
685
+ // for one to affect the verdict — then excluded `relaxed-profile-certified`
686
+ // from its own self-check. The shipped artifact asserted `certified: true`
687
+ // for a profile that cannot certify, and only `--verify` disagreed with the
688
+ // file. A reader who parses `.certified` — the obvious thing to do — got the
689
+ // wrong answer.
681
690
  let relaxations: BundleV3['host']['relaxations'];
682
691
  if (process.env['OPENWOP_HOST_RELAXATIONS']) { try { relaxations = JSON.parse(process.env['OPENWOP_HOST_RELAXATIONS']) as BundleV3['host']['relaxations']; } catch { process.stderr.write('openwop-conformance --certify: OPENWOP_HOST_RELAXATIONS is not JSON\n'); process.exit(2); } }
692
+ // RFC 0173 §A.2: a recorded relaxation denies the profile its obligation
693
+ // belongs to. Matched the same way the verifier matches it, so the emitter
694
+ // and `verifyBundleV3` cannot disagree about the same bundle.
695
+ const relaxedObligations = new Set((relaxations ?? []).map((r) => r.obligation));
696
+ const relaxedProfile = (p: string): boolean => [...relaxedObligations].some((o) => p.includes(o));
697
+ const claimed3 = claimedProfiles.filter((p) => !(p in DEPRECATED_PROFILE_ALIASES)).map((p) => ({ id: p, evidenceTier: args.evidenceTier, witnessCount: witnessCountFor(p), certified: !relaxedProfile(p) && (verdictFor(p)?.certifiable ?? false) && !notHeld.has(p) && !rejectedProfiles.some((v) => v.profile === p) && totals3.blocked === 0 }));
683
698
  const lockPath = resolvePath(conformanceRoot, 'dist', 'spec-artifacts.lock.json');
684
699
  const lock = existsSync(lockPath) ? (JSON.parse(readFileSync(lockPath, 'utf8')) as { version: string; stampSha256: string }) : undefined;
685
700
  const nonPass = rows3.filter((r) => r.result !== 'executed-pass');
@@ -714,7 +729,10 @@ async function runCertify(args: ParsedArgs, baseUrl: string, apiKey: string): Pr
714
729
  const scrubbed3 = scrubEvidence(v3, secrets3);
715
730
  const v3Out = scrubbed3.value as BundleV3;
716
731
  const audit3 = verifyBundleV3(v3Out, { hostPublicKeyPem: publicKeyFromPrivate(signingKeyPem) });
717
- const emitterDefects = audit3.rejections.filter((r) => !['blocked-certified', 'relaxed-profile-certified', 'independent-unverifiable'].includes(r.kind));
732
+ // `relaxed-profile-certified` is no longer excused: the emitter now computes
733
+ // the relaxation into `certified`, so if the verifier still finds that
734
+ // contradiction the bundle is genuinely malformed and MUST NOT be written.
735
+ const emitterDefects = audit3.rejections.filter((r) => !['blocked-certified', 'independent-unverifiable'].includes(r.kind));
718
736
  if (emitterDefects.length > 0) {
719
737
  // Keep the rejected bundle: a self-verification failure with nothing to
720
738
  // inspect sent a host patching a scratch copy of this CLI to see it.